#include "dataSet.h"
#include <math.h>
#include <stdlib.h>
//#include <stdio.h>

//calculate deviation "Q"
double calcSquareDeviation(dataSet* pToDataSet)
{ 
  long i;
  double fdev, fsum = 0; 
  
  for (i=0;i<pToDataSet->vData.liArrLength;i++)
  {
    fdev = pow(pToDataSet->resData.pfArr[i] - pToDataSet->vData.pfArr[i],2);
    fsum += fdev;
  }
  fsum /= pToDataSet->vData.liArrLength;
  return fsum;    
}

double calcStabIndex(double a0, double a2, dataSet* pToDataSet)
{
  double fMeanAccel = 0;
  double fResid = 0, fDiff = 0;
  long i;
  
  for (i=0;i<pToDataSet->aData.liArrLength;i++)
  {
    //ei^2 = (yi - calc(yi))^2
    fResid += pow((-1)*pToDataSet->dDynamicMass * pToDataSet->aData.pfArr[i] - (a0 + a2 * pow(pToDataSet->vData.pfArr[i],2)),2);
    //mean of y
    fMeanAccel += (-1)*pToDataSet->dDynamicMass*pToDataSet->aData.pfArr[i];
  }
  fMeanAccel /= pToDataSet->aData.liArrLength;

  for (i=0;i<pToDataSet->aData.liArrLength;i++)
  {
    //(yi-mean(y))^2
    fDiff += pow(((-1)*pToDataSet->dDynamicMass*pToDataSet->aData.pfArr[i] - fMeanAccel),2);          
  }
  fResid = fResid/fDiff;
  return 1 - fResid;
}