#include "globalVar.h"
#include "dataSet.h"
#include <stdio.h>

void initalizeDataSets()
{
  int i;

  for (i=0;i<NUM_DATA_SETS;i++)
  { 
    arrDataSet[i].aData.iMaxLength = 0;
    arrDataSet[i].aData.liArrLength = 0;
    arrDataSet[i].aData.pfArr = NULL;

    arrDataSet[i].vData.iMaxLength = 0;
    arrDataSet[i].vData.liArrLength = 0;
    arrDataSet[i].vData.pfArr = NULL;

    arrDataSet[i].resData.iMaxLength = 0;
    arrDataSet[i].resData.liArrLength = 0;
    arrDataSet[i].resData.pfArr = NULL;

 
    arrDataSet[i].dDynamicMass = 0;
    arrDataSet[i].dSampleRate = 0;
 

  }
}

void resetDataSet(dataSet* pToDataSet)
{
  freeArray(&(pToDataSet->vData));
  freeArray(&(pToDataSet->aData));
  freeArray(&(pToDataSet->resData));
  
  pToDataSet->dDynamicMass = 0;
  pToDataSet->dSampleRate = 0;

}

void resetAllDataSets()
{
  int i;
  
  for(i=0;i<NUM_DATA_SETS;i++)
  {
    resetDataSet(&(arrDataSet[i]));
  }
}

/** this function: (1) sets start velocity equally (2) brings data sets to same length
 *  arguments: indices from to data sets
 *  return value: 0 - without error; 1 - error
 **/

int equalDataSets(int iFromDataSet, int iToDataSet)
{
  double fMin; // min start velocity
  int iNumDataSets, iIndexOfMin;
  long liMin,i,j; // min length
  
  iNumDataSets = iToDataSet - iFromDataSet + 1;         //number of DataSets

  //find min start velocity
  fMin = arrDataSet[iFromDataSet].vData.pfArr[0];   //initialize min with first start velocity
  iIndexOfMin = iFromDataSet;

  //loop selected data sets
  for (i=iFromDataSet;i<=iToDataSet;i++)
  {
    if (arrDataSet[i].vData.pfArr[0] < fMin)
    {
      fMin = arrDataSet[i].vData.pfArr[0];
      iIndexOfMin = i;
    }
  }

  //remove items > min start velocity
  for (i=iFromDataSet;i<=iToDataSet;i++)
  {
    if(i != iIndexOfMin)
    {
      while (arrDataSet[i].vData.pfArr[0]>arrDataSet[iIndexOfMin].vData.pfArr[0])
      {
        if(0 != removeItem(&(arrDataSet[i].vData), 0))
        {
          return 1;
        }
      }
    }
  }

  //find min length of data sets
  liMin = arrDataSet[iFromDataSet].vData.liArrLength;   //initialize min with length of first DataSet 

  //loop selected data sets
  for (i=iFromDataSet;i<=iToDataSet;i++)
  {
    if (arrDataSet[i].vData.liArrLength < liMin)
    {
      liMin = arrDataSet[i].vData.liArrLength;
    }
  }

  //remove items from data sets to set length to min length
  for (i=iFromDataSet; i<=iToDataSet;i++)
  {
    if (arrDataSet[i].vData.liArrLength > liMin)
    {
      while(arrDataSet[i].vData.liArrLength != liMin)
      {
        j=arrDataSet[i].vData.liArrLength -1;
        if(0 != removeItem(&(arrDataSet[i].vData),j))
        {
          return 1;
        } 
      }
    }
  }

  return 0;
}


