#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "varDoubleArr.h"


/** function to get data out of a file into a variable double array
 *  arguments: filename, pointer to a variable double array (structure VarDoubleArr)
 *  returns an int: 0 without error; 1 error
 */

int readData (char *pcFileName, varDoubleArr *pToStruct)
{
  char a_cBuffer[101] = {'\0'}; //string to get a line out of the file
  FILE *pFile; 

  char a_cDelim[] = " \t;\n"; // delimiters for strtokenizer
  char *pcToken = NULL;       // pointer for single token
  char *pcLastToken = NULL;   // stores the last token
  int iBufLen = 0;            // legth of buffer read
  int bAddLast = 0;           // indicate if last token of buf should be added 0 = FALSE

//  a_cBuffer[0] = '\0';
  pFile = fopen(pcFileName,"rt");

  if (pFile == NULL)
  {
    return 1; //error
  }

  while (NULL != fgets(a_cBuffer,sizeof(a_cBuffer),pFile))//read line
  {
    char *pcReadBuf = NULL;
    if(pcLastToken)
    {
      pcReadBuf = calloc(strlen(pcLastToken) +strlen(a_cBuffer) +1, sizeof(char));
      strcpy(pcReadBuf, pcLastToken);
      strcat(pcReadBuf, a_cBuffer);
      free(pcLastToken);
      pcLastToken = NULL;
    } else
    {
      pcReadBuf = calloc(strlen(a_cBuffer) +1, sizeof(char));
      strcpy(pcReadBuf, a_cBuffer);
    }
    
    iBufLen = strlen(pcReadBuf);
    if(pcReadBuf[iBufLen-1] == '\n' ||
       pcReadBuf[iBufLen-1] == ' '  ||
       pcReadBuf[iBufLen-1] == '\t' ||
       pcReadBuf[iBufLen-1] == ';') 
    {
      // ok, a delimiter is the last char of the buffer, so we can append the last token
      bAddLast = 1; // TRUE
    } else
    {
      char *pcTempToken;
      bAddLast = 0; //FALSE, we will not add the last token!
      // remember "last token"
      // .. try all delimiters from back, if none found: return error
      if(NULL !=  (pcTempToken = strrchr(pcReadBuf, '\n')));
      else if(NULL !=  (pcTempToken = strrchr(pcReadBuf, ' ')));
      else if(NULL !=  (pcTempToken = strrchr(pcReadBuf, '\t')));
      else if(NULL !=  (pcTempToken = strrchr(pcReadBuf, ';')));
      else return 1; // error
      pcLastToken = calloc(strlen(pcTempToken)+1, sizeof(char));
      strcpy(pcLastToken, pcTempToken);
    }
    //check if file is at end, and if EOF, then add the last token regardlessly:
    if(feof(pFile))
    {
      bAddLast = 1; //TRUE
    }
    // read the first token from file:
    pcToken = strtok(pcReadBuf, a_cDelim);
    // "Token;Token;Token; ..."
    if(NULL != pcToken)
    {
      do
      {
        if(addItem(pToStruct,atof(pcToken))!=0) 
        {
          return 1; //error: no memory allocation possible
        }
      } while(pcToken = strtok(NULL, a_cDelim));
    }
    else
    {
      // hm, first token NULL ... do nothing
    }
    // now remove the last added item, if we have to:
    if(bAddLast == 0)
    {
      removeItem(pToStruct, pToStruct->liArrLength -1);
    }
    if(pcReadBuf != NULL)
    {
      free(pcReadBuf);
      pcReadBuf = NULL;
    }
  }
  fclose(pFile);
  return 0; //successfully done
}

/** function to get data out of a file into a variable double array - FORMAT 1
 *  arguments: filename, pointer to a variable double array (structure VarDoubleArr)
 *  returns an int: 0 without error; 1 error
 */

int readDataWithTimeStamp (char *pcFileName, varDoubleArr *pToStruct)
{
  long i = 0;
  char a_cBuffer[101]; //string to get a line out of the file
  char a_cDelim[] = " \t";
  char *pcToken = NULL;
  FILE *pFile;

  a_cBuffer[100] = '\0';
  pFile = fopen(pcFileName,"rt");

  if (pFile == NULL)
  {
    return 1; //error
  }

  while (NULL != fgets(a_cBuffer,sizeof(a_cBuffer),pFile))//read line
  { 
    i=0;
    if(a_cBuffer[strlen(a_cBuffer)-1] == '\n') //erase \n
    {
      a_cBuffer[strlen(a_cBuffer)-1] = '\0'; 
    }

    // to split up a string into parts separated by any symbol    
    pcToken = strtok(a_cBuffer, a_cDelim);
        
    if(NULL != pcToken)
    {
      do
      {
        i++;
        if (i==2) 
        {
          if(addItem(pToStruct,atof(pcToken))!=0) 
          {  
            return 1; //error: no memory allocation possible
          }
        }
      }while(pcToken=strtok(NULL,a_cDelim));
    }
  }
  fclose(pFile);

  return 0; //successfully done
  
}