Attribute VB_Name = "mdAddDataSet"
Option Explicit

Sub AddDataSet(iModeForAdd As Integer)
'iModeForAdd:
'0 Open files for reading
'1 Add already loaded files to list
'3 Open, read file and add to list

    Dim i As Integer
    Dim iErrorValue As Integer
    
    With frmMain
            
        If iNumberOfDataSets < NUMOFMAXFILES Then
    
            'Turn on Error handling
            .cmdlg.CancelError = True
            On Error GoTo errhandler
    
            'Setting flags and check if input is correct
            .cmdlg.Flags = cdlOFNHideReadOnly + cdlOFNPathMustExist + cdlOFNAllowMultiselect + cdlOFNExplorer + cdlOFNFileMustExist
            .cmdlg.Filter = "DataSets (*.txt*.out)|*.txt;*.out|all Fileformats (*.*)|*.*"
            
            'Make sure to have enough memory for filenames
            .cmdlg.MaxFileSize = 30000
            If (iModeForAdd = 0) Or (iModeForAdd = 3) Then
                .cmdlg.ShowOpen
                
                'Split up the path of file(s) and write it into the array sFile
                sFile = Split(.cmdlg.FileName, ChrW$(0))
                
                'Check if user load more then the allowed number of files
                If (UBound(sFile) + iNumberOfDataSets) > NUMOFMAXFILES Then
                    MsgBox ("Number of data-sets is limited to " & NUMOFMAXFILES & "!"), vbInformation
                    frmMain.cmdlg.FileName = ""
                    StartSettingsfrmPreview
                    Exit Sub
                End If
                
                'Check if user has selected one or more files and manipulating path and filename
                If UBound(sFile) = 0 Then
                    ReDim sFile(1)
                    sFile(0) = Mid(.cmdlg.FileName, 1, Len(.cmdlg.FileName) - Len(.cmdlg.FileTitle) - 1)
                    sFile(1) = .cmdlg.FileTitle
                End If
                
                'Add a "\" at the end of the path of the file
                sFile(0) = sFile(0) & "\"
            End If
            
            
            
            For i = 1 To UBound(sFile)
                If (Right(sFile(i), 4) = ".txt" Or Right(sFile(i), 4) = ".out") Then
                    'If '<> "" Then
                    FileRead (sFile(0) & sFile(i))
                                        
                    'Check file structure and produce an error if file format is not correct
                    'If file is empty CheckString-Function produces an error
                    If (iModeForAdd = 1) Or (iModeForAdd = 3) Then '
                    iErrorValue = OpenDataForCheck(i)
                        Select Case iErrorValue
                        Case 0
                            AddtoList PathHandler(sFile(0) & sFile(i)), sFile(i), 0
                            EnalbeButtons
                        Case 1
                            MsgBox "Wrong file format: file " & "'" & sFile(i) & "'", vbExclamation, "WARNING"
                        End Select
                        
                    End If

                Else
                    MsgBox "Wrong file extension: file " & "'" & sFile(i) & "'", vbExclamation, "WARNING"
                End If
                    
            Next i
                    
        Else:
            MsgBox ("Number of data-sets is limited to " & NUMOFMAXFILES & "!"), vbInformation
            frmMain.cmdlg.FileName = ""
            Exit Sub
        End If

    End With
    
errhandler:
Exit Sub
                  
End Sub

Function PathHandler(ByVal sFilePath As String) As String

    With frmMain
    Dim sFilePathHandled As String
    Dim i As Integer

    'Add a "/" to every "/", it's necessary for filehandle in C
    For i = 1 To Len(sFilePath)
        sFilePathHandled = sFilePathHandled & (Mid(sFilePath, i, 1))
        If ((Mid(sFilePath, i, 1))) = "\" Then sFilePathHandled = sFilePathHandled & "\"
    Next i
    
    PathHandler = sFilePathHandled
    
    End With
     
End Function

'Add files to list and set parameters for load
Sub AddtoList(sFilePath As String, sFilename As String, ByVal iAddMode As Integer)
    
    With frmMain.fgrFileTable
    
        iNumberOfDataSets = iNumberOfDataSets + 1
        ReDim Preserve typDataset(iNumberOfDataSets - 1)                'Dimension of types
        ReDim Preserve iSelectedFiles(iNumberOfDataSets - 1)
        
        typDataset(iNumberOfDataSets - 1).FilePath = sFilePath          'Set filepath to dataset
        typDataset(iNumberOfDataSets - 1).FileName = sFilename          'Set filename to dataset
        
        With typDataset(iNumberOfDataSets - 1)
            'Color for draw graphs
            .Color = lColor(iNumberOfDataSets - 1)
            frmMain.picFGColor.BackColor = .Color
            'Set samplerate
            .SampleRate = dSampleRate
            'Set file format
            .FileFormat = iFileFormat
            'If data is given in KM/H
            If iAddMode = 0 Then .Kmh = lConvKMH
            'Data reduction
            .DataReduct = 1
            If bSmoothInputData = 1 Then
                If iAddMode = 0 Then .DataReduct = iFactDataReduct
                .SampleRate = .SampleRate * .DataReduct
            End If
        End With
        
        
        'Add filename
        .Col = 1
        .Row = iNumberOfDataSets                         'Add item to list and combobox(frmDataInput)
        .CellAlignment = 4
        .Text = sFilename
        
        'Add checkbox
        .Col = 0
        .CellPictureAlignment = 4
        Set .CellPicture = frmMain.picChecked(1).Picture
        
        'Add color box
        .Col = 2
        .Row = iNumberOfDataSets
        .CellPictureAlignment = 4
        Set .CellPicture = frmMain.picFGColor.Image
        
        frmMain.lstComp.AddItem (sFilename)
        
        FillCombo
        
    End With
End Sub

'Fill combo in parameters input
Sub FillCombo()

    Dim i As Integer
    
    For i = 0 To iNumberOfDataSets - 1
        'Add item to combo box for data input
        frmDataInput.cmbDataInput.List(i) = typDataset(i).FileName
    Next
    
    If frmDataInput.cmbDataInput.ListCount > 0 Then frmDataInput.cmbDataInput.ListIndex = 0 'Set first element to header of combobox

End Sub

'Check file when opened
Function OpenDataForCheck(CurrFile As Integer) As Integer
    OpenDataForCheck = CheckOptions(iFileFormat, CurrFile) 'in module DataOpenForCheck
End Function
