Attribute VB_Name = "mdAxis"
Option Explicit

'Scale picture box
Public Sub ScalePic(Index As Integer, ByVal dX1 As Double, ByVal dX2 As Double, ByVal dY1 As Double, ByVal dY2 As Double)
    Dim dHeight, dLength As Double
    
    'Scale the selected picture box
    dHeight = dY2 - dY1
    dLength = dX2 - dX1
    
    If Abs(dHeight) < 10 ^ (-8) Then dHeight = dY2 * 0.2
    If Abs(dLength) < 10 ^ (-8) Then dLength = dX1 * 0.2
    
    frmMain.picGraph(Index).Scale (dX1 - dLength * 0.07, dY2 + dHeight * 0.2)-(dX2 + dLength * 0.07, dY1 - dHeight * 0.2)
    
End Sub

'This sub scales the y and x axis for each diagram
Public Sub ScaleAxis(ByVal Index As Integer, ByVal dX1 As Double, ByVal dX2 As Double, ByVal dY1 As Double, ByVal dY2 As Double, ByVal sY As String, ByVal sX As String)

    Dim dIntervCount, dStartY, dStartX, dCoeff As Double
    Dim dStepsizeY As Double
    Dim dStepsizeX As Double
    Dim dScaleFactY As Double
    Dim dScaleFactX As Double
    Dim dHeight, dWidth As Double
    Dim lGridColor As Long
    Dim i As Integer
    
    With frmMain
    
        dHeight = Sqr((dY2 - dY1) ^ 2)              'Calculating height and width of the graph
        dWidth = dX2 - dX1
        
        If dY2 < 0 And dY1 < 0 Then dCoeff = dY2    'Put the axis to the top, if values are negative
        If dY2 > 0 And dY1 > 0 Then dCoeff = dY1
        If dY2 < 0 And dY1 > 0 Then dCoeff = 0
        
        'Set backgroundcolor and forecolor of graphs
        
        If boGraphColor = True Then
            .picGraph(Index).ForeColor = vbWhite
            .picGraph(Index).BackColor = vbBlack
            lGridColor = RGB(50, 50, 50)
        Else
            .picGraph(Index).ForeColor = vbBlack
            .picGraph(Index).BackColor = vbWhite
            lGridColor = RGB(180, 180, 180)
        End If
        
        If Index = 6 Then
            .picGraph(Index + 1).ForeColor = .picGraph(Index).ForeColor
            .picGraph(Index + 1).BackColor = .picGraph(Index).BackColor
            .picGraph(Index + 2).ForeColor = .picGraph(Index).ForeColor
            .picGraph(Index + 2).BackColor = .picGraph(Index).BackColor
            DrawSmallIcon 7, .cmbCompIcon.ListIndex, lNewColor
        End If
        
        'Get the scaling factors for the graph
        ScaleFactor dHeight, dStepsizeY, dScaleFactY
        dIntervCount = Int(dHeight / (dStepsizeY))
        If dIntervCount > 30 Then dIntervCount = 30
        
        'Calculate the start-value for y
        If dY1 > 0 Then
            dStartY = Fix(dY1 * dScaleFactY) - Fix(dY1 * dScaleFactY) Mod (dStepsizeY * dScaleFactY) + (dStepsizeY * dScaleFactY)
        Else: dStartY = -((-Int(dY1 * dScaleFactY)) + Int(dY1 * dScaleFactY) Mod (dStepsizeY * dScaleFactY))
            If dY1 < 0 And dStartY / dScaleFactY < dY1 Then dStartY = dStartY + dStepsizeY * dScaleFactY
        End If
        
        'Decrement the amount of inscription, if it's higher than the maximum of the axis
        If dStartY / dScaleFactY + dStepsizeY * dIntervCount > dY2 Then dIntervCount = dIntervCount - 1
    
        For i = 0 To dIntervCount
            
            'Draw grids
            If bGrids = 1 Then
                .picGraph(Index).ForeColor = lGridColor
                .picGraph(Index).DrawStyle = vbDot
                .picGraph(Index).Line (dX1 + dWidth * 0.005, dStartY / dScaleFactY + i * dStepsizeY)-(dX1 + dWidth, dStartY / dScaleFactY + i * dStepsizeY)
                .picGraph(Index).DrawStyle = vbSolid
                If boGraphColor = True Then .picGraph(Index).ForeColor = vbWhite Else .picGraph(Index).ForeColor = vbBlack
            End If
            
            'Inscribe Y-Axis
            .picGraph(Index).CurrentX = dX1 - dWidth * 0.04 - Len(Str(dStepsizeY)) * dWidth * 4 / 1000
            .picGraph(Index).CurrentY = dStartY / dScaleFactY + i * dStepsizeY + dHeight * 0.04
            .picGraph(Index).Print Round((dStartY / dScaleFactY + i * dStepsizeY), 5)
            .picGraph(Index).Line (dX1 - dWidth * 0.005, dStartY / dScaleFactY + i * dStepsizeY)-(dX1 + dWidth * 0.005, dStartY / dScaleFactY + i * dStepsizeY)
        Next
        
        'Get scaling factors for X-Axis
        ScaleFactor dWidth, dStepsizeX, dScaleFactX
        
        'If lambda is constant, no scaling
        If iCouple < 2 And Index > 1 Then
            dScaleFactX = 1
            dStepsizeX = 1
        End If
        
        dIntervCount = Int(dWidth / (dStepsizeX))
        
        'Plausability check of scaling
        If dIntervCount > 30 And Index < 2 Then
            dIntervCount = -1
            .picGraph(Index).CurrentX = dX2 * 0.5 '- dWidth / 60
            .picGraph(Index).CurrentY = dCoeff - dHeight * 0.02
            sX = "Scaling not possible, wrong sample rate"
            .picGraph(Index).Print sX
            sX = ""
        End If
        
        'Set starting value for X-Axis
        dStartX = Fix(dX1 * dScaleFactX) - Fix(dX1 * dScaleFactX) Mod (dStepsizeX * dScaleFactX) + (dStepsizeX * dScaleFactX)
        If dStartX / dScaleFactX + dStepsizeX * dIntervCount > dX2 Then dIntervCount = dIntervCount - 1
        
      
        For i = 0 To dIntervCount
            
            If i <> dIntervCount Or Index < 2 Or iCouple = 2 Then
                
                'Draw grids
                If bGrids = 1 Then
                    .picGraph(Index).ForeColor = lGridColor
                    .picGraph(Index).DrawStyle = vbDot
                    .picGraph(Index).Line ((dStartX / dScaleFactX + i * dStepsizeX), dY1)-((dStartX / dScaleFactX + i * dStepsizeX), dY2)
                    .picGraph(Index).DrawStyle = vbSolid
                    If boGraphColor = True Then .picGraph(Index).ForeColor = vbWhite Else .picGraph(Index).ForeColor = vbBlack
                End If
                
                'Inscribe x-Axis
                .picGraph(Index).CurrentX = (dStartX / dScaleFactX + i * dStepsizeX) - dWidth * 0.015
                .picGraph(Index).CurrentY = dCoeff - 0.02 * dHeight
                .picGraph(Index).Print (dStartX / dScaleFactX + i * dStepsizeX)
                .picGraph(Index).Line ((dStartX / dScaleFactX + i * dStepsizeX), dCoeff - 0.01 * dHeight)-((dStartX / dScaleFactX + i * dStepsizeX), dCoeff + 0.02 * dHeight)
                
            End If
        Next
        
        'Inscription of the type of the diagram
        .picGraph(Index).CurrentX = dX1 - dWidth * 0.03
            If dCoeff < 0 Then .picGraph(Index).CurrentY = dY1 - dHeight * 0.08 _
            Else: .picGraph(Index).CurrentY = dY2 + dHeight * 0.15
        .picGraph(Index).Print sY
                
        .picGraph(Index).CurrentX = dX2 + dWidth / 60
        .picGraph(Index).CurrentY = dCoeff - dHeight * 0.02
        .picGraph(Index).Print sX
        
        'Draw log(lambda)
        If iCouple = 2 And Index > 1 And Index < 5 Then
            If boGraphColor = True Then
            .picGraph(Index).PaintPicture .picLambda(1), dX2, dCoeff - dHeight * 0.02
                Else: .picGraph(Index).PaintPicture .picLambda(0), dX2, dCoeff - dHeight * 0.02
            End If
        End If
        
        'Draw x-axis
        .picGraph(Index).Line (dX1, dCoeff)-(dX2 + dWidth * 0.02, dCoeff)
        'Draw y-axis
        .picGraph(Index).Line (dX1, dY2)-(dX1, dY1)
           
    End With

End Sub


'This sub calculates the stepsize and the scale-factor value
Private Sub ScaleFactor(ByVal dRange As Double, ByRef dStepsize As Double, ByRef dScaleFact As Double)
    
    Dim i As Integer
    
    If (dRange > 50) Then
        dStepsize = 10
        dScaleFact = 1
    End If
    
    For i = 0 To 15
        If (dRange <= (50 / (10 ^ i)) And dRange > (20 / (10 ^ i))) Then
            dStepsize = (50 / (10 ^ (i + 1)))
            dScaleFact = 10 ^ i
        End If
    Next
    
    For i = 0 To 15
        If (dRange <= (20 / (10 ^ i)) And dRange > (10 / (10 ^ i))) Then
            dStepsize = (20 / (10 ^ (i + 1)))
            dScaleFact = 10 ^ i
        End If
    Next
    
    For i = 0 To 15
        If (dRange <= (10 / (10 ^ i)) And dRange > (5 / (10 ^ i))) Then
            dStepsize = (10 / (10 ^ (i + 1)))
            dScaleFact = 10 ^ i
        End If
    Next
    
End Sub


