Attribute VB_Name = "mdComparison"
Option Explicit

Public Sub RunComparison()

    Dim i, iCountMean As Integer
    Dim dValue(1) As Double
    Dim boErrorNotCalculated As Boolean
    Dim bCompMode As Byte   '0...standard add
                            '1...mean and add
                            '2...add reference
    With frmMain
    
        'Get comparison mode
        For i = 0 To 2
            If .rbCompAdd(i).Value = True Then bCompMode = i
        Next
        
        If bCompMode < 2 Then   '"Standard add" and "mean and add"
        
            If iNumberOfDataSets > 0 Then
                For i = 0 To iNumberOfDataSets - 1
                    If iCompCount(.cmbCompConfig.ListIndex + 1) < 15 Then
                        If .lstComp.Selected(i) = True And typDataset(i).Status > 2 Then
                            If bCompMode = 0 Then
                                'Redimensionize array for several data points
                                ReDim Preserve CompDataPoint(iNrOfCompDataPoints)
                                
                                'Add parameters to type
                                CompDataPoint(iNrOfCompDataPoints).dX = .cmbCompConfig.ListIndex + 1
                                CompDataPoint(iNrOfCompDataPoints).dY(0) = typDataset(i).Cd.darrData(0)
                                CompDataPoint(iNrOfCompDataPoints).dY(1) = typDataset(i).fr0.darrData(0)
                                CompDataPoint(iNrOfCompDataPoints).iIcon = .cmbCompIcon.ListIndex
                                CompDataPoint(iNrOfCompDataPoints).lColor = typDataset(i).Color
                                CompDataPoint(iNrOfCompDataPoints).sText = typDataset(i).FileName
                                
                                'Increase number of datapoints
                                iNrOfCompDataPoints = iNrOfCompDataPoints + 1
                            Else
                                dValue(0) = dValue(0) + typDataset(i).Cd.darrData(0)
                                dValue(1) = dValue(1) + typDataset(i).fr0.darrData(0)
                                iCountMean = iCountMean + 1
                            End If
                        ElseIf typDataset(i).Status < 3 And .lstComp.Selected(i) = True Then
                                boErrorNotCalculated = True
                        End If
                    Else:
                        MsgBox ("The number of datapoints per configuration is limited to 15, data will not be added!"), vbInformation
                        Exit Sub
                    End If
                Next
                
                If bCompMode = 1 And iCountMean > 0 Then
                    'Redimensionize array for several data points
                    ReDim Preserve CompDataPoint(iNrOfCompDataPoints)
                
                    'Add parameters to type
                    CompDataPoint(iNrOfCompDataPoints).dX = .cmbCompConfig.ListIndex + 1
                    CompDataPoint(iNrOfCompDataPoints).dY(0) = dValue(0) / iCountMean
                    CompDataPoint(iNrOfCompDataPoints).dY(1) = dValue(1) / iCountMean
                    CompDataPoint(iNrOfCompDataPoints).iIcon = .cmbCompIcon.ListIndex
                    CompDataPoint(iNrOfCompDataPoints).lColor = lNewColor
                    CompDataPoint(iNrOfCompDataPoints).sText = frmMain.txtCompDiscript
                    
                    'New datapoint
                    iNrOfCompDataPoints = iNrOfCompDataPoints + 1
                    
                    dValue(0) = 0
                    dValue(1) = 0
                    iCountMean = 0
                End If
            End If
            
        Else  'Reference value
            If IsNumeric(.txtCompRef(0).Text) And IsNumeric(.txtCompRef(1).Text) Then
                If CDbl(Del(.txtCompRef(0).Text)) > 0 And CDbl(Del(.txtCompRef(0).Text)) < 1 And CDbl(Del(.txtCompRef(1).Text)) > 0 And CDbl(Del(.txtCompRef(1).Text)) < 1 Then
                    If iCompCount(.cmbCompConfig.ListIndex + 1) < 15 Then
                        'Redimensionize array for several data points
                        ReDim Preserve CompDataPoint(iNrOfCompDataPoints)
                    
                        'Add parameters to type
                        CompDataPoint(iNrOfCompDataPoints).dX = .cmbCompConfig.ListIndex + 1
                        CompDataPoint(iNrOfCompDataPoints).dY(0) = CDbl(Del(.txtCompRef(0).Text))
                        CompDataPoint(iNrOfCompDataPoints).dY(1) = CDbl(Del(.txtCompRef(1).Text))
                        CompDataPoint(iNrOfCompDataPoints).iIcon = .cmbCompIcon.ListIndex
                        CompDataPoint(iNrOfCompDataPoints).lColor = lNewColor
                        CompDataPoint(iNrOfCompDataPoints).sText = frmMain.txtCompDiscript
                        
                        'New datapoint
                        iNrOfCompDataPoints = iNrOfCompDataPoints + 1
                    Else
                        MsgBox ("The number of datapoints per configuration is limited to 15, data will not be added!"), vbInformation
                        Exit Sub
                    End If
                Else
                    MsgBox ("This reference is not valid, it is out of the possible range!"), vbInformation
                    .txtCompRef(0).Text = 0.3
                    .txtCompRef(1).Text = 0.01
                End If
            Else
                MsgBox ("Input data have to be numeric!"), vbInformation
                .txtCompRef(0).Text = 0.3
                .txtCompRef(1).Text = 0.01
            End If
        End If
        
        If boErrorNotCalculated = True Then
            If .rbCompAdd(0).Value = True Then MsgBox ("One or more selected datasets are not calculated yet! Adding was not possible!"), vbCritical
            If .rbCompAdd(1).Value = True Then MsgBox ("One or more selected datasets are not calculated yet! Meaning was done without these datasets!"), vbCritical
            boErrorNotCalculated = False
        End If
                            
        DrawCompIcons
        
        If iNrOfCompDataPoints > 0 Then
            SetCompButtonsEnabledTrue
        End If
    
    End With
End Sub

Private Sub DrawCompIcons()
    
    With frmMain
    
    Dim j, i As Integer
    Dim dMax(1), dMin(1) As Double
    
    If iNrOfCompDataPoints > 0 Then
        
        For j = 0 To 1
                      
            'Inscribe Graphs
            .picGraph(5 + j).Cls
            
            dMax(j) = CompDataPoint(0).dY(j)
            dMin(j) = dMax(j)
            
            'Find the minimum and maximum for scaling
            For i = 0 To iNrOfCompDataPoints - 1
                If dMax(j) < CompDataPoint(i).dY(j) Then dMax(j) = CompDataPoint(i).dY(j)
                If dMin(j) > CompDataPoint(i).dY(j) Then dMin(j) = CompDataPoint(i).dY(j)
            Next
            
            If Abs(dMax(j) - dMin(j)) < 10 ^ (-3) Then
                    dMin(j) = dMin(j) - 10 ^ -3
                    dMax(j) = dMax(j) + 10 ^ -3
            Else:   dMax(j) = dMax(j) * 1.05
                    dMin(j) = dMin(j) * 0.95
            End If
        Next
        
        'Draw axis comparison
        ScalePic 5, 0, 6, dMin(0), dMax(0)                      'Scale pic 5 for Cd Comparison
        ScaleAxis 5, 0, 6, dMin(0), dMax(0), "Cd", "config"     'Draw the axis and inscribe it
        ScalePic 6, 0, 6, dMin(1), dMax(1)                      'Scale pic 6 for fr0 Comparison
        ScaleAxis 6, 0, 6, dMin(1), dMax(1), "fr0", "config"    'Draw the axis and inscribe it

        'Draw Datapoints
        For j = 0 To 1
            For i = 0 To iNrOfCompDataPoints - 1
                DrawIcon 5 + j, CompDataPoint(i).dX, CompDataPoint(i).dY(j), CompDataPoint(i).iIcon, CompDataPoint(i).lColor, 0.006
            Next
        Next
        
        'Initialize and fill the datagrid for comparison
        frmCompDataInscription.InitializeCompDataFlexGrid
        ClearK
        FillTable
        
        'Set all checkboxes in list false
        DeselectList
            
    End If
    

    End With

End Sub

'Set all checkboxes in list false
Private Sub DeselectList()

    Dim i As Integer
    
    For i = 0 To iNumberOfDataSets - 1
        frmMain.lstComp.Selected(i) = False
    Next
    
End Sub

'Initialize chart
Public Sub ClearCompChart()

    Dim i As Integer
    
    With frmMain
    
        .picGraph(5).Cls
        .picGraph(6).Cls
        'Draw axis comparison
        ScalePic 5, 0, 6, 0.1, 0.4                  'Scale pic 5 for Cd Comparison
        ScaleAxis 5, 0, 6, 0.1, 0.4, "Cd", "config" 'Draw the axis and inscribe it
        
        ScalePic 6, 0, 6, 0.01, 0.1                 'Scale pic 5 for Cd Comparison
        ScaleAxis 6, 0, 6, 0.01, 0.1, "fr0", "config" 'Draw the axis and inscribe it

    End With
        
End Sub

'Initialize array
Public Sub ClearCompArray()
    Dim i As Integer
    
    ReDim CompDataPoint(0)
    iNrOfCompDataPoints = 0
    ClearK
End Sub

'Draw several Icons
Public Sub DrawIcon(ByVal iGraphIndex As Integer, ByVal dX As Single, ByVal dY As Single, ByVal iMode As Integer, ByVal lColor As Long, ByVal sSize As Single)

    'iMode: 0...Rectangle
    '       1...Triangle
    '       2...Cross
    '       3...Bar
    
    Dim dHeight, dWidth, dRatio As Single
    
    'Parameter for scaling
    With frmMain
            
        dHeight = .picGraph(iGraphIndex).ScaleHeight
        dWidth = .picGraph(iGraphIndex).ScaleWidth
        dRatio = .picGraph(iGraphIndex).Width / .picGraph(iGraphIndex).Height
   
    
     Select Case iMode
         
         Case 0: .picGraph(iGraphIndex).Line (dX - dWidth * sSize / 1.5, dY - Abs(dRatio * dHeight) * sSize / 1.5)-(dX + dWidth * sSize / 1.5, dY - Abs(dRatio * dHeight) * sSize / 1.5), lColor
                 .picGraph(iGraphIndex).Line -(dX + dWidth * sSize / 1.5, dY + Abs(dRatio * dHeight) * sSize / 1.5), lColor
                 .picGraph(iGraphIndex).Line -(dX - dWidth * sSize / 1.5, dY + Abs(dRatio * dHeight) * sSize / 1.5), lColor
                 .picGraph(iGraphIndex).Line -(dX - dWidth * sSize / 1.5, dY - Abs(dRatio * dHeight) * sSize / 1.5), lColor
         Case 1: .picGraph(iGraphIndex).Line (dX, dY + Abs(dRatio * dHeight) * sSize / 1.5)-(dX + dWidth * sSize / 1.5, dY - Abs(dRatio * dHeight) * sSize / 1.5), lColor
                 .picGraph(iGraphIndex).Line -(dX - dWidth * sSize / 1.5, dY - Abs(dRatio * dHeight) * sSize / 1.5), lColor
                 .picGraph(iGraphIndex).Line -(dX, dY + Abs(dRatio * dHeight) * sSize / 1.5), lColor
         Case 2: .picGraph(iGraphIndex).Line (dX - dWidth * sSize, dY - Abs(dRatio * dHeight) * sSize)-(dX + dWidth * sSize, dY + Abs(dRatio * dHeight) * sSize), lColor
                 .picGraph(iGraphIndex).Line (dX - dWidth * sSize, dY + Abs(dRatio * dHeight) * sSize)-(dX + dWidth * sSize, dY - Abs(dRatio * dHeight) * sSize), lColor
         Case 3: .picGraph(iGraphIndex).Line (dX - dWidth * sSize, dY + Abs(dRatio * dHeight) * sSize / 1.5)-(dX - dWidth * sSize, dY - Abs(dRatio * dHeight) * sSize / 1.5), lColor
                 .picGraph(iGraphIndex).Line (dX + dWidth * sSize, dY + Abs(dRatio * dHeight) * sSize / 1.5)-(dX + dWidth * sSize, dY - Abs(dRatio * dHeight) * sSize / 1.5), lColor
                 .picGraph(iGraphIndex).Line (dX - dWidth * sSize, dY)-(dX + dWidth * sSize, dY), lColor
    
     End Select
    End With
  
End Sub

'Get color for icons
Public Sub GetColor(ByRef lColor As Long)

    With frmMain
        On Error Resume Next
        With frmMain
            .cmdlg.CancelError = True
            .cmdlg.Flags = cdlCCFullOpen
            .cmdlg.ShowColor
        End With
        
        If Err.Number <> cdlCancel Then 'OK entered
            lColor = frmMain.cmdlg.Color
        End If
    End With

End Sub

'Draw the small icons in comparison settings
Public Sub DrawSmallIcon(ByVal Index As Integer, ByVal iMode As Integer, ByVal lColor As Long)
    With frmMain
        .picGraph(Index).Cls
        DrawIcon Index, .picGraph(Index).ScaleWidth / 2, .picGraph(Index).ScaleHeight / 2, iMode, lColor, 0.35
    End With
End Sub

'Fill the table(datagrid) for comparison
Public Sub FillTable()

    Dim j, i As Integer
        
    For i = 0 To iNrOfCompDataPoints - 1
        For j = 0 To 1
            With frmCompDataInscription
                If iCompCount(CompDataPoint(i).dX) > .fgrFileTable(j).Rows - 2 Then .fgrFileTable(j).Rows = .fgrFileTable(j).Rows + 1
                'Fill with values
                .fgrFileTable(j).Col = (CompDataPoint(i).dX - 1) * 2
                .fgrFileTable(j).Row = iCompCount(CompDataPoint(i).dX) + 1
                .fgrFileTable(j).CellAlignment = 4
                .fgrFileTable(j).Text = Round(CompDataPoint(i).dY(j), 5)
 
                'Fill with icons and discription
                .fgrFileTable(j).Col = (CompDataPoint(i).dX - 1) * 2 + 1
                .fgrFileTable(j).Row = iCompCount(CompDataPoint(i).dX) + 1
                .fgrFileTable(j).CellAlignment = 1
                .fgrFileTable(j).Text = "    " & CompDataPoint(i).sText
                DrawSmallIcon 8, CompDataPoint(i).iIcon, CompDataPoint(i).lColor
                Set .fgrFileTable(j).CellPicture = frmMain.picGraph(8).Image
            End With
        Next
        iCompCount(CompDataPoint(i).dX) = iCompCount(CompDataPoint(i).dX) + 1
    Next

End Sub

'Clear memory for the position in the table
Public Sub ClearK()
    
    Dim i As Integer
    'Clear table
    For i = 1 To 5
        iCompCount(i) = 0
    Next
    
End Sub

'Reduce last added data point
Public Sub ReduceCompDataSet()
    
    'Initialize if it is the last data point
    If iNrOfCompDataPoints = 1 Then
        frmMain.cmdCompClearChart_Click
        SetCompButtonsEnabledFalse
    Else
        ReDim Preserve CompDataPoint(iNrOfCompDataPoints - 1)
        iNrOfCompDataPoints = iNrOfCompDataPoints - 1
        ClearK
        frmCompDataInscription.InitializeCompDataFlexGrid
        FillTable
        DrawCompIcons
    End If
    
End Sub

'Control buttons
Public Sub SetCompButtonsEnabledFalse()
        With frmMain
            .cmdCompStepBack.Enabled = False
            .chkDataInscription.Enabled = False
            .cmdCompClearChart.Enabled = False
            .chkCompSettings.Value = 0
            .chkCompSettings_Click
            frmCompDataInscription.Form_Unload (1)
        End With
End Sub

Private Sub SetCompButtonsEnabledTrue()
        With frmMain
            .cmdCompStepBack.Enabled = True
            .chkDataInscription.Enabled = True
            .cmdCompClearChart.Enabled = True
        End With
End Sub

