Attribute VB_Name = "mdDataInput"
Option Explicit

Function CheckInputData() As Integer    'Check if input data is valid
    
    CheckInputData = 0  'Data is valid
    
    With frmDataInput
    
    'Check if the entered data is numeric
    
    If IsNumeric(.txtFrontalArea.Text) And _
          IsNumeric(.txtMass.Text) And _
          IsNumeric(.txtPressure.Text) And _
          IsNumeric(.txtTemperature.Text) And (IsNumeric(.txtDynamicMass.Text) Or .chkEnterDynamicMass.Value = 0) Then
            
             'Check if the entered data is in the possible range
            
            If CDbl(Del(.txtTemperature.Text)) < -100 Or CDbl(Del(.txtTemperature.Text)) > 100 Then
                MsgBox ("This temperature is not valid, it is out of the possible range!"), vbInformation
                .txtTemperature.Text = 14.9
                CheckInputData = 1 'Data is not valid
            End If
            
            If CDbl(Del(.txtPressure.Text)) < 10000 Or CDbl(Del(.txtPressure.Text)) > 150000 Then
                MsgBox ("This pressure is not valid, it is out of the possible range!"), vbInformation
                .txtPressure.Text = 95520
                CheckInputData = 1
            End If
            
            If CDbl(Del(.txtFrontalArea.Text)) <= 0 Or CDbl(Del(.txtFrontalArea.Text)) > 10 Then
                MsgBox ("This frontal area is not valid, it is out of the possible range!"), vbInformation
                .txtFrontalArea.Text = 2.06
                CheckInputData = 1
            End If
            
            If CDbl(Del(.txtMass.Text)) < 500 Or CDbl(Del(.txtMass.Text)) > 50000 Then
                MsgBox ("This mass of the vehicle is not valid, it is out of the possible range!"), vbInformation
                 .txtMass.Text = 1598
                CheckInputData = 1
            End If
            
            If .chkEnterDynamicMass.Value = 1 Then
                If CDbl(Del(.txtDynamicMass.Text)) < CDbl(Del(.txtMass.Text)) Or CDbl(Del(.txtDynamicMass.Text)) > 50000 Then
                    MsgBox ("This dynamic mass of the vehicle is not valid, it is out of the possible range!"), vbInformation
                    .chkEnterDynamicMass.Value = 0
                    .txtDynamicMass.Text = ""

                    CheckInputData = 1
                End If
            End If
    Else
            MsgBox ("Input data have to be numeric!"), vbInformation
            CheckInputData = 1
    End If
    End With
    
End Function

Sub AddInputData(iInd As Integer)  'Add the content of the text-boxes to the dataset

    With frmDataInput
        
        'Set the values to dataset
        typDataset(iInd).Temperature = CDbl(Del(.txtTemperature.Text)) + 273.15
        typDataset(iInd).Pressure = CDbl(Del(.txtPressure.Text))
        typDataset(iInd).Mass = CDbl(Del(.txtMass.Text))
        typDataset(iInd).FrontalArea = CDbl(Del(.txtFrontalArea.Text))
        If frmDataInput.chkEnterDynamicMass.Value = 1 Then
            typDataset(iInd).DynamicMass = CDbl(Del(.txtDynamicMass.Text))
            typDataset(iInd).DynamicMassSet = 1
        Else: typDataset(iInd).DynamicMass = 0
            typDataset(iInd).DynamicMassSet = 0
        End If
        
        typDataset(iInd).Status = 2
    
    End With
    
End Sub


Sub SetEnabledFalse()   'Set all textboxes disabled
    
    With frmDataInput
        
        .txtPressure.Enabled = False
        .txtTemperature.Enabled = False
        .txtMass.Enabled = False
        .txtFrontalArea.Enabled = False
        
        .chkEnterDynamicMass.Enabled = False
        .txtDynamicMass.Enabled = False
        .lblDynamicMass.Enabled = False
        .lblUnit(2).Enabled = False
        
        .cmdDataInput.Enabled = False
        .cmdChangeData.Enabled = True
    
    End With
    
End Sub

Sub SetEnabledTrue()    'Set all textboxes enabled
    
    With frmDataInput
        
        .txtPressure.Enabled = True
        .txtTemperature.Enabled = True
        .txtMass.Enabled = True
        
        .txtFrontalArea.Enabled = True
        .chkEnterDynamicMass.Enabled = True
        
        If .chkEnterDynamicMass.Value = 1 Then
            .lblDynamicMass.Enabled = True
            .lblUnit(2).Enabled = True
            .txtDynamicMass.Enabled = True
        End If
        
        .cmdDataInput.Enabled = True
        .cmdChangeData.Enabled = False
    
    End With
    
End Sub

Sub CheckDataSet()      'Check the status of the actual data set
    
     With frmDataInput
     
     If typDataset(.cmbDataInput.ListIndex).Status >= 2 Then
        DataOutput
        SetEnabledFalse
     End If
     
    If typDataset(.cmbDataInput.ListIndex).Status < 2 Then
        SetEnabledTrue
        DataFieldsInit
    End If
     
    End With

End Sub

Sub DataOutput()    'Output of the content of the dataset

    Dim iInd As Integer
    
    With frmDataInput
        
        iInd = .cmbDataInput.ListIndex

        .txtTemperature.Text = typDataset(iInd).Temperature - 273.15
        .txtPressure.Text = typDataset(iInd).Pressure
        .txtMass.Text = typDataset(iInd).Mass
        .txtFrontalArea.Text = typDataset(iInd).FrontalArea
        .chkEnterDynamicMass.Value = typDataset(iInd).DynamicMassSet
        If typDataset(iInd).DynamicMassSet = 1 Then .txtDynamicMass.Text = typDataset(iInd).DynamicMass Else .txtDynamicMass.Text = ""

    End With
    
End Sub

Sub DataFieldsInit()    'Initialize the content of the text boxes

    With frmDataInput
    
        .txtTemperature.Text = 20
        .txtPressure.Text = 101365
        .txtMass.Text = 2000
        .txtFrontalArea.Text = 2
        .chkEnterDynamicMass.Value = 0
        .txtDynamicMass.Text = ""

    End With

End Sub
