Attribute VB_Name = "mdDataOpenForCheck"
Option Explicit

Public Function CheckOptions(iFileFormat As Integer, CurrFile As Integer) As Integer

    'Ascii Codes:
        'Space: 32
        '";" : 59
        'Tab: 9
        'Enter: 10
        
    Dim iError As Integer

    Select Case iFileFormat
    
        'Space Enter
        Case 0: iError = CheckString(2, "32,", "10,", CurrFile)
                If iError = 0 Then iError = fSampleRate
        'Enter
        Case 1: iError = CheckString(1, "10,", "", CurrFile)
         
        '";"
        Case 2: iError = CheckString(1, "59,", "", CurrFile)
               
        'Space
        Case 3: iError = CheckString(1, "32,", "", CurrFile)
        
        'Tab
        Case 4: iError = CheckString(1, "09,", "", CurrFile)
    
    End Select

    CheckOptions = iError
        
End Function

Function CheckString(intCase As Integer, breakChar1 As String, breakChar2 As String, CurrFile As Integer) As Integer

'Errors:
'0 - no error
'1 - file has not the right structure
'2 - file is empty

Dim i As Long
Dim k As Integer
Dim lDataPointsNr As Long

Dim a As String
Dim b As String

Dim sSolution As String
Dim sLongString As String
           
With frmMain

    'Set FileName
    sBuffer = FileRead(sFile(0) & sFile(CurrFile), 1, 400)
    
    
    'Exit function and return an errorvalue if file is empty
    If sBuffer = "" Then
        MsgBox "File '" & sFile(CurrFile) & "' is empty!", vbCritical
        'Error
        CheckString = 2
        Exit Function
    Else
    
        For i = 1 To Len(sBuffer)
            a = Asc(Mid(sBuffer, i, 1))
            If a = "9" Then a = "09"
            If a = 32 Or a = 59 Or a = "09" Or a = 10 Then
                sSolution = sSolution & a & ","
            End If
        Next i
        
        'if file has only one line without any delimiters -> error
        If sSolution = "" Then
            CheckString = 1
            Exit Function
        End If
        
        lDataPointsNr = Len(sSolution) / 3 - 1
    
        Select Case intCase
            ' Enter, Space, ; , Tab
            Case 1
                For i = 0 To lDataPointsNr
                    
                    If IsNumeric(Split(sBuffer, Chr(Mid(breakChar1, 1, 2)))(i)) Then
                        CheckString = 0
                    Else
                        'Error
                        CheckString = 1
                    Exit Function
                    End If
                Next i
                    
                For i = 0 To lDataPointsNr
                    If Mid(sSolution, i * 3 + 1, 3) = breakChar1 Then
                        CheckString = 0
                    Else
                        'Error
                        CheckString = 1
                        Exit Function
                    End If
                Next i
                
            
            Case 2
            ' Space, Enter
                'Check if enter follows space
                  For i = 0 To lDataPointsNr
                    If i Mod 2 = 0 Then
                        If Mid(sSolution, i * 3 + 1, 3) = breakChar1 Then
                            CheckString = 0
                        Else
                            'Error
                            CheckString = 1
                            Exit Function
                        End If
                    Else
                        If Mid(sSolution, i * 3 + 1, 3) = breakChar2 Then
                            CheckString = 0
                        Else
                            'Error
                            CheckString = 1
                            Exit Function
                        End If
                    End If
                Next i
               
               'Check if numbers numeric
               For i = 0 To Fix(lDataPointsNr / 2)
                'Split file in single strings
                sLongString = Split(sBuffer, vbCrLf)(i)
                    For k = 0 To 1
                            'Check if the secondary strings are numeric
                        If IsNumeric((Split(sLongString, " ")(k))) And Split(sLongString, " ")(k) <> sLongString Then
                            CheckString = 0
                        Else
                            CheckString = 1
                            Exit Function
                        End If
                        
                    Next k
               Next i
               
               If lDataPointsNr < 3 Then
                     CheckString = 1
                    Exit Function
                End If
               
               
             
            
        
        End Select
    End If

End With
End Function


Public Function FileRead(ByVal sFile As String, _
  Optional ByVal nStartPos As Long = 1, _
  Optional ByVal nBytesToRead As Long = 0) As String
  
  '****************************
  On Error Resume Next
  '****************************
  
  Dim F As Integer
  Dim nFileLen As Long
  
  ' Open file in Binary-Mode
  F = FreeFile
  Open sFile For Binary As #F
  
  ' Size of file in bytes
  nFileLen = LOF(F)
  
  ' If "BytesToRead" not set or 0,
  ' Read whole file from "StartPos"
  If nBytesToRead = 0 Then nBytesToRead = nFileLen
  
  ' If StartPos < 1, Bytes read file backward from
  ' End of file
    If nStartPos < 1 Then
    nStartPos = nFileLen
    nBytesToRead = -Abs(nBytesToRead)
  End If
  
  ' If "StartPos" > size of file and
  ' "BytesToRead" < 0, end function
  If nStartPos > nFileLen And nBytesToRead < 0 Then
    Close #F
    Exit Function
  End If
  
  'Search reading position in the file
  If nBytesToRead < 1 Then
    nBytesToRead = Abs(nBytesToRead)
    nStartPos = nStartPos - nBytesToRead + 1
    If nStartPos < 1 Then
      nBytesToRead = nBytesToRead - Abs(nStartPos) - 1
      nStartPos = 1
    End If
  End If
  
  If nStartPos + nBytesToRead - 1 > nFileLen Then
    nBytesToRead = nFileLen - nStartPos + 1
  End If
  
  'Go to the wanted position to start reading file and
  'read file, at first sbuffer="" because there
  'would be an error if the file is empty
  sBuffer = ""
  sBuffer = Space$(nBytesToRead)
  Seek #F, nStartPos
  Get #F, , sBuffer
  
  ' Close file
  Close #F
  
  FileRead = sBuffer
  
End Function

Private Function fSampleRate() As Integer

Dim LongString1 As String
Dim LongString2 As String
Dim ShortString1 As String
Dim ShortString2 As String


    'Cut string in pieces
    LongString1 = Split(sBuffer, vbCrLf)(0)
    LongString2 = Split(sBuffer, vbCrLf)(1)
    
    'Cut string in pieces ones more
    ShortString1 = Split(LongString1, " ")(0)
    ShortString2 = Split(LongString2, " ")(0)
    
    'Calculate sample rate
    dSampleRate = CDbl(Del(ShortString2)) - CDbl(Del(ShortString1))
    If (dSampleRate > 10 ^ -5 And dSampleRate < 10) Then
        fSampleRate = 0
    Else:  fSampleRate = 1
        dSampleRate = 0.1
    End If
    
End Function




