Attribute VB_Name = "mdDraw"
Option Explicit
Dim iSFforGraph(NUMOFMAXFILES) As Integer

Public Sub RunDraw()
   
    DelDataSets                       'Delete all datasets in memory
    ResetGraphs                       'Clear all diagrams
    lNumberOfSDS = SelectionCheck     'Get the number of selected files
    
    If lNumberOfSDS > 0 Then
        
        If bDraw = False Then
            DrawVelocities                'Draw velocity data (data points)
            DrawAccelerations             'Draw accelerations
                                          'Draw Cd and fr0
            If iCouple < 2 Then DrawCdFr0LambdaConst Else:  DrawCdFr0LambdaVar
        Else
            DrawVelocities
        End If
        
    Else: MsgBox ("No files selected!"), vbInformation
    End If

End Sub

 Sub DrawVelocities()

    Dim l As Long
    Dim dLength As Double
    Dim lReadError As Long
    Dim dMinValue As Double
    Dim dMaxValue As Double
        
    'Draw vData
    For l = 0 To lNumberOfSDS - 1
    
        If typDataset(iSelectedFiles(l)).Status = 0 Or typDataset(iSelectedFiles(l)).Status = 2 Then
        
            lReadError = ReadDataSets(l, typDataset(iSelectedFiles(l)).FileFormat)
            If lReadError = 0 Then                 'Read the data sets in sequence
                        MemCopy1 l                       'Copy memory from C-Array to VB-Array
                        If typDataset(iSelectedFiles(l)).Status = 0 Then typDataset(iSelectedFiles(l)).Status = 1
            ElseIf lReadError = 2 Then          'Data reduction error
                    MsgBox ("Smooth of dataset " & typDataset(iSelectedFiles(l)).FileName & " was not successful, factor of data reduction is too high!"), vbCritical
                    DelDataSets                 'Reset all data sets in dll
                    Exit Sub
            Else:
                    MsgBox ("Read of dataset " & typDataset(iSelectedFiles(l)).FileName & " was not successful!"), vbCritical
                    DelDataSets                     'Reset all data sets in dll
                    Exit Sub
            End If
        End If
            
        iSFforGraph(l) = iSelectedFiles(l)
    Next
    
    'Get the maximum size which is necessary to draw all of the data sets
    GetSizeofGraph lNumberOfSDS, 0, dLength, dMinValue, dMaxValue
    'Check if difference between max and min is big enough
    MaxMinCheck dMaxValue, dMinValue
    'Draw velocities
    Draw lNumberOfSDS, 0, 0, dLength, dMinValue, dMaxValue

End Sub

Sub DrawAccelerations()

    Dim l As Long
    Dim dLength As Double
    Dim dMinValue As Double
    Dim dMaxValue As Double

    lNumberOfCalc = 0
   
   ' Draw acceleration-data
        For l = 0 To lNumberOfSDS - 1
            If (typDataset(iSelectedFiles(l)).Status >= 3) Then    'Get files which are already calculated
                iSFforGraph(lNumberOfCalc) = iSelectedFiles(l)
                lNumberOfCalc = lNumberOfCalc + 1
            End If
        Next
    
    If lNumberOfCalc > 0 Then
        GetSizeofGraph lNumberOfCalc, 1, dLength, dMinValue, dMaxValue
        MaxMinCheck dMaxValue, dMinValue                        'Check if difference between max and min is big enough
        Draw lNumberOfCalc, 1, 0, dLength, dMinValue, dMaxValue 'Draw acceleration
    End If

End Sub

 Sub Draw(lNumber As Long, iDiagramNr As Integer, dStart As Double, dLength As Double, dMinValue As Double, dMaxValue As Double)

    Dim lCounter As Long
    Dim i As Integer
    
    frmMain.picGraph(iDiagramNr).Cls
    
    If bZoom(iDiagramNr) = False Then frmMain.chkZoomIn(iDiagramNr).Enabled = True
    frmMain.picGraph(iDiagramNr).AutoRedraw = True
    
    'Scale of Picbox
    ScalePic iDiagramNr, dStart, dLength, dMinValue, dMaxValue
    If iDiagramNr = 0 Then ScaleAxis iDiagramNr, dStart, dLength, dMinValue, dMaxValue, "v(t) , m/s", "t , s" _
    Else ScaleAxis iDiagramNr, dStart, dLength, dMinValue, dMaxValue, "a(t) , m/s", "t , s"
   
    'Draw graphs
    For i = 0 To lNumber - 1
        With typDataset(iSFforGraph(i))
        For lCounter = Int(dStart / .SampleRate) To .arrData(0).dLength - 1
                frmMain.picGraph(iDiagramNr).PSet (lCounter * .SampleRate, .arrData(iDiagramNr).darrData(lCounter)), .Color
                'Draw solutions of ODE if chk is enabled
                If (iDiagramNr = 0 And frmOptions.chkDrawSolutionOfODE.Value = 1 And lCounter < .arrData(0).dLength - 2 And .Status > 2) Then _
                frmMain.picGraph(iDiagramNr).Line (lCounter * .SampleRate, .arrData(iDiagramNr + 2).darrData(lCounter))-((lCounter + 1) * .SampleRate, .arrData(iDiagramNr + 2).darrData(lCounter + 1)), .Color
        Next
        End With
    Next
    
End Sub

'Get the size of the graph for velocities and accelerations

Private Sub GetSizeofGraph(lNumber As Long, iDiagramNr As Integer, ByRef dLength As Double, ByRef dMinValue As Double, ByRef dMaxValue As Double)
    
    Dim i As Integer
    
    With typDataset(iSFforGraph(i)).arrData(iDiagramNr)
        dMinValue = .dMin
        dMaxValue = .dMax
    End With
    
    For i = 0 To lNumber - 1                  'Get size of the graph
        With typDataset(iSFforGraph(i))
            If dLength < .arrData(iDiagramNr).dLength * .SampleRate Then dLength = .arrData(iDiagramNr).dLength * .SampleRate
            If dMinValue > .arrData(iDiagramNr).dMin Then dMinValue = .arrData(iDiagramNr).dMin
            If dMaxValue < .arrData(iDiagramNr).dMax Then dMaxValue = .arrData(iDiagramNr).dMax
        End With
    Next

End Sub

Private Sub DrawCdFr0LambdaConst()

    Dim i, j As Integer
    Dim dX1 As Double
    Dim dX2 As Double
    Dim dMinValue As Double
    Dim dMaxValue As Double
    Dim dHeight As Double
    Dim dWidth As Double
    
    If lNumberOfCalc > 0 Then   'There are calculated data sets
        
        'Parameters for drawing
        dX1 = 0
        dX2 = lNumberOfCalc + 1
        dWidth = dX2 - dX1
        
        For j = 0 To 2
        
            GetSizeOf lNumberOfCalc, dMinValue, dMaxValue, dHeight, j   'Get size of graph
            MaxMinCheck dMaxValue, dMinValue                            'Check if difference between max and min is big enough
            ScalePic j + 2, dX1, dX2, dMinValue, dMaxValue              'Scale pic
            
            Select Case j
                Case 0: ScaleAxis j + 2, dX1, dX2, dMinValue - dHeight * 0.05, dMaxValue, "Cd", "config" 'Draw the axis and inscribe it
                        For i = 0 To lNumberOfCalc - 1
                            'frmMain.picGraph(j + 2).PSet (i + 1, typDataset(iSelectedFiles(i)).Cd.darrData(0)), typDataset(iSelectedFiles(i)).Color
                            DrawIcon j + 2, i + 1, typDataset(iSelectedFiles(i)).Cd.darrData(0), 0, typDataset(iSelectedFiles(i)).Color, 0.005
                        Next
                Case 1: ScaleAxis j + 2, dX1, dX2, dMinValue - dHeight * 0.05, dMaxValue, "fr0", "config" 'Draw the axis and inscribe it
                        For i = 0 To lNumberOfCalc - 1
                            'frmMain.picGraph(j + 2).PSet (i + 1, typDataset(iSelectedFiles(i)).fr0.darrData(0)), typDataset(iSelectedFiles(i)).Color
                            DrawIcon j + 2, i + 1, typDataset(iSelectedFiles(i)).fr0.darrData(0), 0, typDataset(iSelectedFiles(i)).Color, 0.005
                        Next
                Case 2: ScaleAxis j + 2, dX1, dX2, dMinValue - dHeight * 0.05, dMaxValue, "Q", "config" 'Draw the axis and inscribe it
                        For i = 0 To lNumberOfCalc - 1
                            'frmMain.picGraph(j + 2).PSet (i + 1, typDataset(iSelectedFiles(i)).Q.darrData(0)), typDataset(iSelectedFiles(i)).Color
                            DrawIcon j + 2, i + 1, typDataset(iSelectedFiles(i)).Q.darrData(0), 0, typDataset(iSelectedFiles(i)).Color, 0.005
                        Next
            End Select
            
        Next
    End If
    
End Sub

'This sub draws Cd and fr0 relating to variable lambda
Private Sub DrawCdFr0LambdaVar()

    Dim i, j, k As Integer
    Dim dX1 As Double
    Dim dX2 As Double
    Dim dMaxValue As Double
    Dim dMinValue As Double
    Dim dHeight As Double
     Dim dWidth As Double
    
    If lNumberOfSDS > 0 Then  'There are files with variable lambda
        
        'Parameters for drawing lambda axis
        dX1 = Log10(dLMin)
        dX2 = Log10(dLMax)
        dWidth = dX2 - dX1
        
        For k = 0 To 2
        
            GetSizeOf lNumberOfCalc, dMinValue, dMaxValue, dHeight, k       'Get range for drag coefficients
            MaxMinCheck dMaxValue, dMinValue                                'Check if difference between max and min is big enough
            ScalePic k + 2, dX1, dX2, dMinValue, dMaxValue                  'Scale pic
            
            Select Case k
                Case 0: ScaleAxis k + 2, dX1, dX2, dMinValue, dMaxValue, "Cd", "" 'Draw axis and inscribe it
                        'Draw graph Cd
                        For j = 0 To lNumberOfCalc - 1
                            For i = 1 To iNrOfLambdas - 1
                                With typDataset(iSFforGraph(j)).Cd
                                    frmMain.picGraph(k + 2).Line (Log10(dLambda(i - 1)), .darrData(i - 1))-(Log10(dLambda(i)), .darrData(i)), typDataset(iSFforGraph(j)).Color
                                End With
                            Next
                        Next
                Case 1: ScaleAxis k + 2, dX1, dX2, dMinValue, dMaxValue, "fr0", ""  'Draw axis and inscribe it
                         'Draw graph fr0
                        For j = 0 To lNumberOfCalc - 1
                            For i = 1 To iNrOfLambdas - 1
                                With typDataset(iSFforGraph(j)).fr0
                                    frmMain.picGraph(k + 2).Line (Log10(dLambda(i - 1)), .darrData(i - 1))-(Log10(dLambda(i)), .darrData(i)), typDataset(iSFforGraph(j)).Color
                                End With
                            Next
                        Next
                Case 2: ScaleAxis k + 2, dX1, dX2, dMinValue, dMaxValue, "Q", ""  'Draw axis and inscribe it
                        'Draw graph Q
                        For j = 0 To lNumberOfCalc - 1
                            For i = 1 To iNrOfLambdas - 1
                                With typDataset(iSFforGraph(j)).Q
                                    frmMain.picGraph(k + 2).Line (Log10(dLambda(i - 1)), .darrData(i - 1))-(Log10(dLambda(i)), .darrData(i)), typDataset(iSFforGraph(j)).Color
                                End With
                            Next
                        Next
            End Select
            If k < 2 Then frmMain.chkRef(k).Visible = True

        Next
        
        
    End If
    
End Sub

Private Sub GetSizeOf(ByVal lNumber As Long, ByRef dMinValue As Double, ByRef dMaxValue As Double, ByRef dHeight As Double, ByVal iMode As Integer)
    
    Dim i, j As Integer
    
        Select Case iMode
            Case 0:
                With typDataset(iSFforGraph(0)).Cd 'Get the minimum/maximum to scale the picture box
                    dMinValue = .darrData(0)
                    dMaxValue = .darrData(0)
                End With
            Case 1:
                With typDataset(iSFforGraph(0)).fr0
                    dMinValue = .darrData(0)
                    dMaxValue = .darrData(0)
                End With
            Case 2:
                With typDataset(iSFforGraph(0)).Q
                    dMinValue = .darrData(0)
                    dMaxValue = .darrData(0)
                End With
        End Select
        
        If iNrOfLambdas > 1 Then        'Variable lambda
            For j = 0 To iNrOfLambdas - 1 Step iNrOfLambdas - 1
                For i = 0 To lNumber - 1       'Get the minimum/maximum to scale the picture box
                    Select Case iMode
                        Case 0:
                            With typDataset(iSFforGraph(i)).Cd
                                If dMinValue > .darrData(j) Then dMinValue = .darrData(j)
                                If dMaxValue < .darrData(j) Then dMaxValue = .darrData(j)
                            End With
                        Case 1:
                            With typDataset(iSFforGraph(i)).fr0
                                If dMinValue > .darrData(j) Then dMinValue = .darrData(j)
                                If dMaxValue < .darrData(j) Then dMaxValue = .darrData(j)
                            End With
                        Case 2:
                            With typDataset(iSFforGraph(i)).Q
                                If dMinValue > .darrData(j) Then dMinValue = .darrData(j)
                                If dMaxValue < .darrData(j) Then dMaxValue = .darrData(j)
                            End With
                    End Select
                Next
            Next
        Else                                'Lambda is null or constant
             For i = 0 To lNumber - 1       'Get the minimum/maximum to scale the picture box
                Select Case iMode
                      Case 0:
                          With typDataset(iSFforGraph(i)).Cd
                              If dMinValue > .darrData(j) Then dMinValue = .darrData(j)
                              If dMaxValue < .darrData(j) Then dMaxValue = .darrData(j)
                          End With
                      Case 1:
                          With typDataset(iSFforGraph(i)).fr0
                              If dMinValue > .darrData(j) Then dMinValue = .darrData(j)
                              If dMaxValue < .darrData(j) Then dMaxValue = .darrData(j)
                          End With
                      Case 2:
                          With typDataset(iSFforGraph(i)).Q
                              If dMinValue > .darrData(j) Then dMinValue = .darrData(j)
                              If dMaxValue < .darrData(j) Then dMaxValue = .darrData(j)
                          End With
                  End Select
            Next
        
        End If
        
        dHeight = dMaxValue - dMinValue     'Calculating height of picture box
        
        If dHeight = 0 Then                 'If there is only one dataset
            dHeight = dMaxValue / 10
            dMinValue = dMaxValue - dHeight
        End If
        
End Sub

Private Sub MaxMinCheck(ByRef dMax As Double, ByRef dMin As Double)
    
        If Abs(dMax - dMin) > 10 ^ (-5) Then
                    If dMin > 0 Then dMin = dMin * 0.99 Else dMin = dMin * 1.01
                    If dMax > 0 Then dMax = dMax * 1.01 Else dMax = dMax * 0.99
            Else:   dMax = dMax + 10 ^ -3
                    dMin = dMin - 10 ^ -3
        End If
            
End Sub




