Attribute VB_Name = "mdMean"
Option Explicit

Private Declare Function MeanDataSets Lib _
"V33.dll" _
Alias "DLLMeanDataSets" (ByVal sFilename As String, ByVal iNrDataSets As Long) As Long

'This function creats a new dataset by building mean values out of existing data sets

Public Sub RunMean()

    Dim NumberOfSelectedDS As Long
    Dim sFilename As String
    Dim l As Long
    Dim lReadError As Long
    Dim blnReadSuccessful As Boolean
    
    DelDataSets                                     'Delete all datasets
    ResetGraphs                                     'Clear graph
    NumberOfSelectedDS = SelectionCheck             'Get the number of selected files
    
    If NumberOfSelectedDS < 2 Then                  'Minimum two selected files
             MsgBox ("For mean you need at least two datasets!"), vbInformation
    Else
        If PlausabilityCheck(NumberOfSelectedDS) = 0 Then   'Plausability function worked without error
                
                For l = 0 To NumberOfSelectedDS - 1
                    lReadError = ReadDataSets(l, typDataset(iSelectedFiles(l)).FileFormat)
                    If lReadError = 0 Then                  'Read the data sets in sequence
                            blnReadSuccessful = True        'Readdata was successful
                    ElseIf lReadError = 2 Then          'Data reduction error
                            blnReadSuccessful = False
                            MsgBox ("Smooth of dataset " & typDataset(iSelectedFiles(l)).FileName & " was not successful, factor of data reduction is too high!"), vbCritical
                            DelDataSets                 'Reset all data sets in dll
                            Exit Sub
                    Else:   blnReadSuccessful = False       'Readdata was not successful
                            MsgBox ("Read of dataset " & typDataset(iSelectedFiles(l)).FileName & " was not successful!"), vbCritical
                            DelDataSets                     'Reset all data sets in dll
                            Exit Sub
                    End If
                Next
                                
                If blnReadSuccessful = True Then                'All datasets added succesfully
                
                    On Error Resume Next                         'Get Filepath
                        With frmMain.cmdlg
                            .CancelError = True
                            .Flags = cdlOFNFileMustExist + cdlOFNPathMustExist + cdlOFNExplorer + cdlOFNNoChangeDir + cdlOFNOverwritePrompt
                            .Filter = "DataSets (*.txt)|*.txt"
                            .ShowSave
                            
                        End With
        
                        If Err.Number <> cdlCancel Then 'OK entered
                        
                            sFilename = PathHandler(frmMain.cmdlg.FileName)
                            If (MeanDataSets(sFilename, NumberOfSelectedDS)) = 0 Then
                                                             'Remove selected data sets
                                AddtoList sFilename, frmMain.cmdlg.FileTitle, 1     'Add meaned data set to list
                                typDataset(iNumberOfDataSets - 1).SampleRate = typDataset(iSelectedFiles(0)).SampleRate
                                RemoveSelected (True)
                                DelDataSets                                         'Reset all data sets in dll
                            Else: MsgBox ("The calculation of the mean value was not successful!"), vbCritical
                            End If
                        End If
                End If
        Else: MsgBox ("Files have not the same sample-rate!"), vbCritical
        End If
    
        'frmMain.cmdlg.FileName = ""
    End If

End Sub

Public Function PlausabilityCheck(lNumber As Long)

    Dim l As Long
    
    For l = 0 To lNumber - 1      'Check if the sanple rate is the same for all files
        With typDataset(iSelectedFiles(l))
            If typDataset(iSelectedFiles(0)).SampleRate <> .SampleRate Then PlausabilityCheck = 1
        End With
    Next

End Function


