Attribute VB_Name = "mdOptions"
Option Explicit

'Comtrol tab
Public Sub SettingsTab()

    Dim i As Integer

    With frmOptions
   
    For i = 0 To .TabOptions.Tabs.Count - 1
        
        If i = .TabOptions.SelectedItem.Index - 1 Then
            .picOptions(i).Top = .TabOptions.Top + 480
            .picOptions(i).Left = .TabOptions.Left + 200
            .picOptions(i).Width = .TabOptions.Width - 400
            .picOptions(i).Height = .TabOptions.Height - 660
            
            .picOptions(i).Enabled = True
            .picOptions(i).Visible = True
            
        Else
            '.picOptions(i).Enabled = False
            .picOptions(i).Visible = False
          
        End If
    Next i
    End With
    

End Sub

'Save settings
Public Sub SaveOptionSettings()
    
    Dim i As Byte
    
    Select Case bOptionsCalledByPreview     'Set forms enabled=true again
        Case 0
            frmMain.Enabled = True
        Case 1
            frmPreview.Enabled = True
    End Select
        
    bOptionsCalledByPreview = 0
    
    With frmOptions                         'Save settings
        
        bDelimiterForDataInput = .cmbDelimiterForInput.ListIndex
        If bDelimiterForDataInput = 1 Then      'Change Delimiter
            sContains = ","
            sExchange = "."
        Else
            sContains = "."
            sExchange = ","
        End If
                
        bLambdaConst = .optLambdaConst.Value
        bLambdaVar = .optLambdaVariable.Value
        dValLambdaConst = Del(.txtLambdaConst.Text)
        dVarLambdaFrom = Del(.txtLambdaVar(0))
        dVarLambdaTo = Del(.txtLambdaVar(1))
        iStep = .sldLambdaVar.Value
        boFormat1 = .rbFormat(0).Value
        boFormat2 = .rbFormat(1).Value
        boFormat3 = .rbFormat(2).Value
        dSamplerate2 = Del(.txtSampleRate(0).Text)
        dSamplerate3 = Del(.txtSampleRate(1).Text)
        lConvKMH1 = .chkKMH(0).Value
        lConvKMH2 = .chkKMH(1).Value
        lConvKMH3 = .chkKMH(2).Value
        bShowODE = .chkDrawSolutionOfODE.Value
        boGraphColor = .rbBlackorWhite(0)
        bPreview = .chkPreview.Value
        boCouplingMode = .rbCd(1).Value
        bGrids = .chkShowGrids.Value
        bDelimiter = .cmbDelimiter.ListIndex
        bSmoothInputData = .chkSmoothInputData.Value
        iFactDataReduct = .sldDataReduct.Value
        
        If boCouplingMode = True Then lCouplingMode = 0 Else lCouplingMode = 1
 
    End With

End Sub

'Initialize options
Sub OptionsInit()

    Select Case bOptionsCalledByPreview
        Case 0
            frmMain.Enabled = False
            frmOptions.TabOptions.Tabs(1).Selected = True
        Case 1
            frmPreview.Enabled = False
            frmOptions.TabOptions.Tabs(3).Selected = True
    End Select
    
    With frmOptions
        'Add items to combobox
        .cmbDelimiter.Clear
        .cmbDelimiter.AddItem (";")
        .cmbDelimiter.AddItem ("'Space'")
        .cmbDelimiter.AddItem ("'Tab'")
        .cmbDelimiter.ListIndex = 1
        .rbFormat(1).Value = True
        
        'Initialize frmOptions
        .optLambdaConst.Value = bLambdaConst
        .optLambdaVariable.Value = bLambdaVar
        .txtLambdaConst.Text = dValLambdaConst
        If dVarLambdaFrom = 0 Then dVarLambdaFrom = 1
        If dVarLambdaTo = 0 Then dVarLambdaTo = 1000
        .txtLambdaVar(0) = dVarLambdaFrom
        .txtLambdaVar(1) = dVarLambdaTo
        .sldLambdaVar.Value = iStep
        .rbFormat(0).Value = boFormat1
        .rbFormat(1).Value = boFormat2
        .rbFormat(2).Value = boFormat3
        If dSamplerate2 = 0 Then dSamplerate2 = 0.1
        If dSamplerate3 = 0 Then dSamplerate3 = 0.1
        .txtSampleRate(0).Text = dSamplerate2
        .txtSampleRate(1).Text = dSamplerate3
        .chkKMH(0).Value = lConvKMH1
        .chkKMH(1).Value = lConvKMH2
        .chkKMH(2).Value = lConvKMH3
        .chkDrawSolutionOfODE.Value = bShowODE
        .rbBlackorWhite(0) = boGraphColor
        .rbBlackorWhite(1) = Not (boGraphColor)
        .chkPreview.Value = bPreview
        .rbCd(1).Value = boCouplingMode
        .chkShowGrids.Value = bGrids
        .cmbDelimiter.ListIndex = bDelimiter
        .cmbDelimiterForInput.ListIndex = bDelimiterForDataInput
        .chkSmoothInputData.Value = bSmoothInputData
        .sldDataReduct.Value = iFactDataReduct
        
    End With

End Sub

'Get and calculate values for lambda
Public Function LambdaManipulation() As Integer

    Dim dRangeForLambda As Double
    Dim i As Integer
    
    With frmOptions
    
    If .optLambdaConst.Value = True Then     'Lambda is constant
    
        If IsNumeric(.txtLambdaConst.Text) Then  'Input check
            If CDbl(Del(.txtLambdaConst.Text)) < 0 Or CDbl(Del(.txtLambdaConst.Text)) > 10 ^ 12 Then
                    MsgBox ("This lambda is not valid, it is out of the possible range!")
                    .txtLambdaConst.Text = 100
                    LambdaManipulation = 1 'Error
            Else
                ReDim dLambda(0)
                dLambda(0) = CDbl(Del(.txtLambdaConst.Text))  'Set lambda constant
            End If
        Else:
            MsgBox ("Input data have to be numeric!")
            .txtLambdaConst.Text = 100
            LambdaManipulation = 1  'Error
        End If
    End If
    
    If .optLambdaVariable.Value = True Then 'Lambda is variable
    
        If (IsNumeric(.txtLambdaVar(0).Text) And IsNumeric(.txtLambdaVar(1).Text)) Then
            If CDbl(Del(.txtLambdaVar(0).Text)) < 1 Or CDbl(Del(.txtLambdaVar(0).Text)) > 10 ^ 12 Or CDbl(Del(.txtLambdaVar(0).Text)) > CDbl(Del(.txtLambdaVar(1).Text)) Or CDbl(Del(.txtLambdaVar(1).Text)) < 1 Or CDbl(Del(.txtLambdaVar(1).Text)) > 10 ^ 12 Then
                    MsgBox ("This range for lambda is not valid, it is out of the possible range!")
                    .txtLambdaVar(0).Text = 10
                    .txtLambdaVar(1).Text = 1000
                    LambdaManipulation = 1      'Error
            Else
                iNrOfLambdas = frmOptions.sldLambdaVar.Value
                ReDim dLambda(iNrOfLambdas)
                
                dLMin = CDbl(Del(.txtLambdaVar(0).Text))  'Lower limit for lambda
                dLMax = CDbl(Del(.txtLambdaVar(1).Text))  'Upper limit for lambda
                
                dRangeForLambda = Log10(dLMax) - Log10(dLMin)
                
                For i = 0 To iNrOfLambdas - 1 'Calculate lambdas
                    dLambda(i) = Round(10 ^ (Log10(dLMin) + dRangeForLambda * i / (iNrOfLambdas - 1)), 0)
                Next
            End If
        Else:
            MsgBox ("Input data have to be numeric!")
            .txtLambdaVar(0).Text = 10
            .txtLambdaVar(1).Text = 1000
            LambdaManipulation = 1  'Error
        End If
    End If
    
    End With
End Function

'Get file format
Public Function FormatManipulation() As Integer

    With frmOptions
    
    Dim i As Integer
    
    If .rbFormat(1).Value = True Then
        i = 0                                   'Default: return and line feed
        If .chkKMH(1).Value = 1 Then lConvKMH = 1 Else lConvKMH = 0
    ElseIf .rbFormat(2).Value = True Then
        i = 1                                   'Delimiter: ";" , Space or Tab
        If .chkKMH(2).Value = 1 Then lConvKMH = 1 Else lConvKMH = 0
    ElseIf .rbFormat(0).Value = True Then        'Space Enter
        iFileFormat = 0
        If .chkKMH(0).Value = 1 Then lConvKMH = 1 Else lConvKMH = 0
        Exit Function
    End If
     
    'Plausability check
    If IsNumeric(.txtSampleRate(i).Text) Then
        If CDbl(Del(.txtSampleRate(i).Text)) < 10 ^ -5 Or CDbl(Del(.txtSampleRate(i).Text)) > 30 Then
                MsgBox ("This sample rate is not valid, it is out of the possible range!")
                .txtSampleRate(i).Text = 0.1
                FormatManipulation = 1 'Error
        Else
            dSampleRate = CDbl(Del(.txtSampleRate(i).Text))
            iFileFormat = i + 1
            If i = 1 Then iFileFormat = iFileFormat + .cmbDelimiter.ListIndex    '";" , Space or Tab
        End If
    Else:
        MsgBox ("Input data have to be numeric!")
        .txtSampleRate(i).Text = 0.1
        FormatManipulation = 1 'Error
    End If
    
    End With

End Function
