Attribute VB_Name = "mdPrint"
Option Explicit
    
Dim iHeightOfCell, iWidthOfColumn As Integer
Dim iPageW, iPageH As Integer
Dim iStartTableLeft As Integer
Dim iStartTableTop, iVertAlign As Integer
Dim iHeightOfGraph, iWidthofGraph  As Integer
    
Public Sub Print_Document()

    Dim iNumCopies, i As Integer
    
    iPageW = 210
    iPageH = 279
    
    iHeightOfCell = iPageH * 0.02
    iStartTableLeft = iPageW * 0.1
    iStartTableTop = iPageH * 0.2
    iVertAlign = iHeightOfCell * 0.25
    
    iWidthofGraph = iPageW * 0.85
    iHeightOfGraph = iWidthofGraph * 0.27
  
    If iNumberOfDataSets = 0 Then
        MsgBox ("Printing is not possible without datasets!")
        Exit Sub
    Else
        Dim objDialog As Object
        Set objDialog = CreateObject("MSComDlg.CommonDialog")
      
        On Error GoTo dbErrHandler
      
        With objDialog
        
            .CancelError = True
        
            'Show dialogbox
            .ShowPrinter
            
            'Call user settings
            iNumCopies = .Copies
        
            If Err.Number = 0 Then
            
                For i = 1 To iNumCopies
                  
                    frmMain.AutoRedraw = True
                    Printer.ScaleMode = vbMillimeters
                    Printer.Scale (0, 0)-(210, 279)
                                 
                    If frmPrint.chkPrintData(1).Value Or frmPrint.chkPrintData(0) = 1 Then
                        
                        PrintHead
                        'Input Data
                        If frmPrint.chkPrintData(0).Value = 1 Then
                            PrintInscription iStartTableTop * 0.7, "Input"
                            PrintTable 0, 0, 5
                        End If
                        
                        'Output Data
                        If frmPrint.chkPrintData(0).Value = 1 And frmPrint.chkPrintData(1).Value Then
                            PrintInscription iStartTableTop * 0.7 + iNumberOfDataSets * iHeightOfCell + 30, "Output"
                            PrintTable 1, iNumberOfDataSets * iHeightOfCell + 30, 6
                        ElseIf frmPrint.chkPrintData(1).Value = 1 Then
                            PrintInscription iStartTableTop * 0.7, "Output"
                            PrintTable 1, 0, 6
                        End If
                        
                        Printer.NewPage
                        
                    End If
    
                    'Print graphs
                    If frmPrint.chkPrintGraph(0).Value Or frmPrint.chkPrintGraph(1) Or frmPrint.chkPrintGraph(2) Or _
                    frmPrint.chkPrintGraph(3) Or frmPrint.chkPrintGraph(4) = 1 Then
                        PrintHead
                        PrintInscription iStartTableTop * 0.7, "Graphs"
                        PrintGraphs
                        Printer.NewPage
                    End If
                    
                    
                    If frmPrint.chkPrintComp(0).Value = 1 Or frmPrint.chkPrintComp(1).Value = 1 Then
                        PrintHead
                        
                        If frmPrint.chkPrintComp(0).Value = 1 Then
                            PrintInscription iStartTableTop * 0.7, "Comparison Cd"
                            PrintComparison 0
                        End If
                        
                        If frmPrint.chkPrintComp(1).Value = 1 Then
                            If frmPrint.chkPrintComp(0).Value = 1 Then
                                Printer.NewPage
                                PrintHead
                            End If
                            PrintInscription iStartTableTop * 0.7, "Comparison fr0"
                            PrintComparison 1
                        End If
                    End If
                Next
                Printer.EndDoc
            End If
        End With
     
dbErrHandler:
        Exit Sub
    
    Set objDialog = Nothing
    End If

End Sub


Public Sub PrintHead()

    'Print head
    Printer.CurrentY = iPageH * 0.04
    Printer.CurrentX = iStartTableLeft
    Printer.FontUnderline = False
    Printer.Print "Aero-Drag Calculator V1.0 | TeamBGN"
    Printer.RightToLeft = True
    Printer.CurrentX = iPageH * 0.85
    Printer.CurrentY = iPageH * 0.04
    Printer.Print Date
    Printer.Line (0, iPageH * 0.07)-(iPageW, iPageH * 0.07)

End Sub

Private Sub PrintInscription(ByVal iStartY As Integer, ByVal sString As String)
    
    'Print title
    Printer.CurrentY = iStartY
    Printer.CurrentX = iPageW * 0.45
    Printer.FontBold = True
    Printer.FontSize = 10
    Printer.FontItalic = True
    Printer.Print sString
    Printer.FontBold = False
    Printer.FontItalic = False
    Printer.FontSize = 8

End Sub

Private Sub PrintTable(ByVal iMode As Integer, ByVal iStartPos As Integer, ByVal iNrOfCol As Integer)

With Printer
    
    Dim i, j As Integer
    Dim iPY As Integer
    Dim iWidthOfFirstColumn As Integer
    
    iWidthOfFirstColumn = iPageW * 0.85 * 0.22
    iWidthOfColumn = iPageW * 0.85 * 0.78 / iNrOfCol
    
    
    'Horizontal line
    For i = 0 To iNumberOfDataSets
        Printer.Line (iStartTableLeft, iStartTableTop + i * iHeightOfCell + iStartPos)-(iStartTableLeft + iWidthOfFirstColumn + iNrOfCol * iWidthOfColumn, iStartTableTop + i * iHeightOfCell + iStartPos), vbGrayText
    Next
    
     'Vertical line
    For i = iStartTableLeft + iWidthOfFirstColumn To iStartTableLeft + iWidthOfFirstColumn + iNrOfCol * iWidthOfColumn Step iWidthOfColumn
        Printer.Line (i, iStartTableTop - iHeightOfCell + iStartPos)-(i, iStartTableTop + iNumberOfDataSets * iHeightOfCell + iStartPos), vbGrayText
    Next
    
    Printer.Line (iStartTableLeft + iWidthOfFirstColumn - 1, iStartTableTop - iHeightOfCell + iStartPos)-(iStartTableLeft + iWidthOfFirstColumn - 1, iStartTableTop + iNumberOfDataSets * iHeightOfCell + iStartPos), vbGrayText
    
    'Inscribe table
    Printer.CurrentX = iStartTableLeft + 10
    Printer.CurrentY = iStartTableTop - iHeightOfCell + iVertAlign + iStartPos
    Printer.FontBold = True
    Printer.Print "Filename"
   
    For i = 0 To iNrOfCol - 1

        Printer.CurrentX = iStartTableLeft + iWidthOfFirstColumn + iWidthOfColumn * i + 2
        Printer.CurrentY = iStartTableTop - iHeightOfCell + iVertAlign + iStartPos
        
        Select Case iMode
            Case 0:
                Select Case i
                    Case 0:     Printer.Print "Frontal Area (m)"
                    Case 1:     Printer.Print "Mass (kg)"
                    Case 2:     Printer.Print "Pressure (Pa)"
                    Case 3:     Printer.Print "Temperature (C)"
                    Case 4:     Printer.Print "Dynamic Mass (kg)"
                End Select
            Case 1:
                Select Case i
                    Case 0:     Printer.Print "Density (kg/m)"
                    Case 1:     Printer.Print "Cd"
                    Case 2:     Printer.Print "fr0"
                    Case 3:     Printer.Print "a0"
                    Case 4:     Printer.Print "a2"
                    Case 5:     Printer.Print "Q"
                End Select
        End Select
    
    Next
  
    Printer.FontBold = False

    'Fill table with values and print the color-box

    For i = 0 To iNumberOfDataSets - 1
    
        iPY = iStartTableTop + iVertAlign + i * iHeightOfCell + iStartPos

        Printer.CurrentX = iStartTableLeft + 3
        Printer.CurrentY = iPY
        Printer.Print typDataset(i).FileName

        Printer.Line (iStartTableLeft, iPY)-(iStartTableLeft + 2, iPY + 4), typDataset(i).Color, BF
        
        For j = 0 To iNrOfCol - 1
        
            Printer.CurrentX = iStartTableLeft + iWidthOfFirstColumn + iWidthOfColumn * j + 1
            Printer.CurrentY = iPY
            
            Select Case iMode
                Case 0:
                    Select Case j
                        Case 0: Printer.Print Round(typDataset(i).FrontalArea, 5)
                        Case 1: Printer.Print Round(typDataset(i).Mass, 5)
                        Case 2: Printer.Print Round(typDataset(i).Pressure, 5)
                        Case 3: If typDataset(i).Temperature <> 0 Then Printer.Print Round(typDataset(i).Temperature - 273.15, 5) _
                                Else Printer.Print "0"
                        Case 4: Printer.Print Round(typDataset(i).DynamicMass, 5)
                    End Select
                Case 1:
                    If typDataset(i).Status > 2 Then
                        Select Case j
                            Case 0: Printer.Print Round(typDataset(i).Density, 5)
                            Case 1: Printer.Print Round(typDataset(i).Cd.darrData(0), 5)
                            Case 2: Printer.Print Round(typDataset(i).fr0.darrData(0), 5)
                            Case 3: Printer.Print Round(typDataset(i).A0.darrData(0), 5)
                            Case 4: Printer.Print Round(typDataset(i).A2.darrData(0), 5)
                            Case 5: Printer.Print Round(typDataset(i).Q.darrData(0), 5)
                        End Select
                    Else: Printer.Print "0"
                    End If
            End Select
        Next
    Next

End With
    
End Sub

Private Sub PrintGraphs()

    Dim i As Integer
    Dim iGraphCounter, iPosGraphTitle As Integer
    Dim iSpaceBetween As Integer
    
    iPosGraphTitle = iPageH * 0.02
    iSpaceBetween = iPageH * 0.07
    
    For i = 0 To 4
        
        If bPrintsettings(i + 2) = 1 Then
        
            'If user wants to print more than 3 graphs a new page will be printed
            If iGraphCounter = 3 Then
                Printer.NewPage
                PrintHead
                PrintInscription iStartTableTop * 0.7, "Graphs"
                iGraphCounter = 0
            End If
        
    
            'Print title of graphs
            Printer.CurrentY = iStartTableTop - iPosGraphTitle + iGraphCounter * (iHeightOfGraph + iSpaceBetween)
            Printer.CurrentX = iStartTableLeft
            
            Printer.FontBold = True
            
            Select Case i
                Case 0
                    Printer.Print "v(t)"
                Case 1
                    Printer.Print "a(t)"
                Case 2
                    Printer.Print "Cd(c)"
                Case 3
                    Printer.Print "fr0(c)"
                Case 4
                    Printer.Print "Q(c)"
            End Select
            
        Printer.FontBold = False
        
        'Print graphs
        Printer.PaintPicture frmMain.picGraph(i).Image, iStartTableLeft, iStartTableTop + iGraphCounter * (iHeightOfGraph + iSpaceBetween), iWidthofGraph, iHeightOfGraph
        
        
        iGraphCounter = iGraphCounter + 1
    End If
Next i
                        
End Sub

Private Sub PrintComparison(ByVal iMode As Integer)

    Dim iMaxCompD, i, j, k As Integer
    iMaxCompD = 0
    iWidthOfColumn = iPageW * 0.85 / 10
    iHeightOfGraph = iPageH * 0.21
    iWidthofGraph = iHeightOfGraph / 0.35
    
    For i = 1 To 5
        If iCompCount(i) > iMaxCompD Then iMaxCompD = iCompCount(i)
    Next
    
     'Horizontal line
    For i = 0 To iMaxCompD
        Printer.Line (iStartTableLeft, iStartTableTop + i * iHeightOfCell)-(iStartTableLeft + iWidthOfColumn * 10, iStartTableTop + i * iHeightOfCell), vbGrayText
    Next
    
     'Vertical line
    For i = 1 To 10
        Printer.Line (iStartTableLeft + iWidthOfColumn * i, iStartTableTop - iHeightOfCell)-(iStartTableLeft + iWidthOfColumn * i, iStartTableTop + iHeightOfCell * iMaxCompD), vbGrayText
    Next
    
    'Inscribe first row
    For i = 1 To 10
        Printer.CurrentX = iWidthOfColumn * i + 4
        Printer.CurrentY = iStartTableTop - iHeightOfCell + iVertAlign
        Printer.FontBold = True
        If (i + 1) Mod 2 = 0 Then Printer.Print "Config " & (i - 1) / 2 + 1
        Printer.FontBold = False
    Next
    
    For j = 1 To 10 Step 2
        For i = 0 To iNrOfCompDataPoints - 1
            If CompDataPoint(i).dX = (j - 1) / 2 + 1 Then
                Printer.CurrentX = iWidthOfColumn * j + 4
                Printer.CurrentY = iStartTableTop + iVertAlign + iHeightOfCell * k
                Printer.Print Round(CompDataPoint(i).dY(iMode), 5)
                
                Printer.CurrentX = iWidthOfColumn * (j + 1) + 8
                Printer.CurrentY = iStartTableTop + iVertAlign + iHeightOfCell * k
                If Len(CompDataPoint(i).sText) > 6 Then Printer.Print Mid(CompDataPoint(i).sText, 1, 6) _
                Else Printer.Print CompDataPoint(i).sText
                
                DrawSmallIcon 8, CompDataPoint(i).iIcon, CompDataPoint(i).lColor
                Printer.CurrentX = iWidthOfColumn * (j + 1) + 4
                Printer.CurrentY = iStartTableTop + iVertAlign + iHeightOfCell * k
                Printer.PaintPicture frmMain.picGraph(8).Image, iWidthOfColumn * (j + 1) + 4, iStartTableTop + iVertAlign + iHeightOfCell * k, iWidthOfColumn * 0.15, iHeightOfCell * 0.6
                k = k + 1
            End If
        Next
        k = 0
    Next
    
    'Print header for graph
    Printer.CurrentY = iPageH * 0.55 - iHeightOfCell
    Printer.CurrentX = iStartTableLeft
            
    Printer.FontBold = True
    If iMode = 0 Then Printer.Print "Cd Comparison Graph" _
    Else Printer.Print "fr0 Comparison Graph"
    
    Printer.FontBold = False
    
    'Print graphs
    Printer.PaintPicture frmMain.picGraph(5 + iMode).Image, iStartTableLeft, iPageH * 0.55, iWidthofGraph, iHeightOfGraph
    
End Sub

