Attribute VB_Name = "mdStructure"
Type Arr

    darrData() As Double
    dMin As Double
    dMax As Double
    dLength As Long
    
End Type

Type Dataset                    'DataSet for the files with properties, inputs and outputs
    
    FilePath As String
    FileName As String
    FileFormat As Long
    Kmh As Long
    Temperature As Double
    Pressure As Double
    FrontalArea As Double
    Mass As Double
    SampleRate As Double
    Density As Double
    DynamicMass As Double
    DynamicMassSet As Byte
    DataReduct As Integer
    Color As Long
    Status As Integer           'Status of the DataSet:
                                '0 means nothing set
                                '1 means measured velocities are set
                                '2 means input data is set
                                '3 means output data is set
                                '4 means data was coupled
                                '5 means data was coupled with variable lambda
                                
    arrData(3) As Arr           'Velocites, accelerations, solved velocites out of ODE
    A0 As Arr                   'Arrays necessary for variable lambda
    A2 As Arr
    Cd As Arr
    fr0 As Arr
    Q As Arr
    
End Type

Global Const NUMOFMAXFILES As Integer = 10
Global Const MAGNIF As Integer = 100

Global typDataset() As Dataset

Global iSelectedFiles() As Integer
Global iNumberOfDataSets As Integer
Global lNumberOfCalc As Long
Global lNumberOfSDS As Long

Global bChecked(NUMOFMAXFILES) As Boolean
Global bZoom(NUMOFMAXFILES) As Boolean
Global lColor(NUMOFMAXFILES)
Global dSampleRate As Double
Global iFileFormat As Integer
Global iCouple As Integer
Global iNrOfLambdas As Integer
Global dLambda() As Double
Global lConvKMH As Long
Global bDraw As Boolean
Global dLMin, dLMax As Double
Global sFile() As String
Global lCouplingMode As Long
Global sContains As String
Global sExchange As String

'For checking file
Global sBuffer As String

'For saving option settings
Global bLambdaConst As Byte
Global bLambdaVar As Byte
Global dValLambdaConst As Double
Global dVarLambdaFrom As Double
Global dVarLambdaTo As Double
Global iStep As Integer
Global boFormat1 As Boolean
Global boFormat2 As Boolean
Global boFormat3 As Boolean
Global dSamplerate2 As Double
Global dSamplerate3 As Double
Global lConvKMH1 As Long
Global lConvKMH2 As Long
Global lConvKMH3 As Long
Global bShowODE As Byte
Global bPreview As Byte
Global bGrids As Byte
Global boGraphColor As Boolean
Global boCouplingMode As Boolean
Global bDelimiter As Byte
Global bDelimiterForDataInput As Byte
Global bSmoothInputData As Byte
Global iFactDataReduct As Integer

Global bPrintsettings(8) As Byte


Global bCalcAutomaticAfterDatainput As Byte
    'This Value has to be set for calculating automatically after
    'the input window
    '0 -> standard setting
    '1 -> from calculate-button (frmMain)
    '2 -> from couple-button (frmMain)
Global bOptionsCalledByPreview As Byte

'Comparison
Global lNewColor As Long
Global iNrOfCompDataPoints As Integer
Global iCompCount(5) As Integer
Global CompDataPoint() As CompDataPoint

'Type for comparison

Type CompDataPoint
    dX As Double
    dY(1) As Double
    iIcon As Integer
    lColor As Long
    sText As String
End Type

'Reference
Global bRefIndex As Byte

Public Function Log10(ByVal dX As Double)

  If dX > 0 Then Log10 = Log(dX) / Log(10)
   
End Function
